
Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

KORIG    EQU       5ch-103h                 ; korekce pro posun programu

Start:   jmp       Init                     ; instalace programu

RezBeg   label     near                     ; zatek rezidentn sti

DevNext  dd        -1                       ; adresa dalho zazen
DevAtrib dw        8013h                    ; atributy zazen
DevStrat dw        offset Strateg+KORIG     ; adresa obsluhy strategie
DevPrer  dw        offset Prerus+KORIG      ; adresa obsluhy peruen
DevName  db        'CON     '               ; jmno zazen CON

Old1B    dd        0                        ; pvodn adresa INT 1Bh
Old29    dd        0                        ; pvodn adresa INT 29h

Request  dd        0                        ; adresa poadavku zazen

BuffKey  db        0                        ; buffer uschovan klvesy

Atrib    db        7                        ; atributy barev
AktPage  db        0                        ; aktuln videostrnka

Pozice   db        0                        ; ta pozice na dku displeje
Radek    db        0                        ; ta dku na displeji

Pozic    db        80                       ; poet pozic na dek
MaxRadek db        24                       ; posledn dek na displeji

CitEsc   dw        0                        ; ta znak pro ESC
BuffEsc  db        20 dup(0)                ; buffer znak ESC
Wrap     db        0                        ; 0=pznak funkce WRAP

IdentBeg label     near                     ; zatek k identifikaci programu

; -----------------------------------------------------------------------------
;        obsluha strategie zazen
; -----------------------------------------------------------------------------

Strateg  PROC      FAR

         mov       word ptr cs:[Request+KORIG],bx ; offset adresy poadavku
         mov       word ptr cs:[Request+2+KORIG],es ; segment adresy poadavku
         ret

Strateg  ENDP

; -----------------------------------------------------------------------------
;        obsluha rutiny peruen
; -----------------------------------------------------------------------------

Prerus   PROC      FAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ pprava parametr poadavku zazen

         lds       bx,cs:[Request+KORIG]    ; adresa poadavku zazen
         mov       cx,ds:[bx+12h]           ; poet bajt pro penos
         mov       al,ds:[bx+2]             ; kd poadovanho povelu
         cbw                                ; AX <- AL
         mov       si,offset TabFn+KORIG    ; tabulka adres obsluh funkc
         add       si,ax
         add       si,ax                    ; adresa v tabulce
         cmp       al,0bh                   ; povolen slo funkce ?
         ja        Prerus2                  ; chybn slo funkce
         les       di,ds:[bx+0eh]           ; adresa bufferu k penosu
         push      cs
         pop       ds
         jmp       ds:[si]                  ; skok na obsluhu funkce

; ------ chyba - zazen nepipraveno

Prerus1: mov       ah,3                     ; pznak - zazen nepipraveno
         jmp       short Prerus4

; ------ chyba - chybn slo funkce

Prerus2: mov       ax,8103h                 ; pznak chyby - neznm povel
         jmp       short Prerus4

; ------ nvrat z funkce OK

Prerus3: mov       ah,1                     ; pznak - akce provedena OK
Prerus4: lds       bx,cs:[Request+KORIG]    ; adresa zhlav poadavku
         mov       ds:[bx+3],ax             ; uloen nvratovho kdu

; ------ nvrat registr

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

Prerus   ENDP

; -----------------------------------------------------------------------------
;        obsluha peruen Ctrl-Break
; -----------------------------------------------------------------------------

INT1B    PROC      FAR

         mov       byte ptr cs:[BuffKey+KORIG],3 ; znak Ctrl-Break
         iret

INT1B    ENDP

IdentEnd label     near                     ; konec k identifikaci programu

; -----------------------------------------------------------------------------
;        obsluha zobrazen znaku INT 29h
; -----------------------------------------------------------------------------

INT29    PROC      FAR

         sti
         push      ds
         push      cs
         pop       ds
         call      OutChr                   ; vstup znaku AL
         pop       ds
         iret

INT29    ENDP

; -----------------------------------------------------------------------------
;        tabulka adres obsluh
; -----------------------------------------------------------------------------

TabFn    label     word                     ; tabulka adres obsluh
         dw        Prerus2+KORIG            ; 0 inicializace zazen (chyba)
         dw        Prerus1+KORIG            ; 1 kontrola mdia (OK)
         dw        Prerus1+KORIG            ; 2 vystavn bloku BPB (OK)
         dw        Prerus2+KORIG            ; 3 vstup kanlu IOCTL (chyba)
         dw        FN04+KORIG               ; 4 vstup (ten ze zazen)
         dw        FN05+KORIG               ; 5 nedestruktivn vstup
         dw        Prerus1+KORIG            ; 6 statut vstupu (OK)
         dw        FN07+KORIG               ; 7 vyprzdnn vstupu
         dw        FN08+KORIG               ; 8 vstup (zpis na zazen)
         dw        FN09+KORIG               ; 9 vstup s verifikac
         dw        Prerus1+KORIG            ; 10 statut vstupu (OK)
         dw        Prerus1+KORIG            ; 11 vyprzdnn vstupu (OK)

; -----------------------------------------------------------------------------
;        zobrazen znaku AL na displeji BIOS
; -----------------------------------------------------------------------------

DispChr  PROC      NEAR

; ------ obsluha CR

         cmp       al,0dh                   ; je CR
         jne       DispChr0
         mov       byte ptr ds:[Pozice+KORIG],0 ; nulovn ukazatele pozice
         jmp       DispChr8                 ; nastaven nov pozice kurzoru

; ------ obsluha LF

DispChr0:cmp       al,0ah                   ; je LF ?
         je        DispChr6                 ; posun o dek dol

; ------ obsluha BEL

         cmp       al,7                     ; je BEL ?
         jne       DispChr3                 ; nen BEL
DispChr1:mov       bx,word ptr ds:[Atrib+KORIG] ; atributy a videostrnka
         mov       ah,0eh
         int       10h                      ; ppnut
DispChr2:ret

; ------ obsluha BS

DispChr3:cmp       al,8                     ; je BS ?
         jne       DispChr4                 ; nen BS
         cmp       byte ptr ds:[Pozice+KORIG],0 ; je ji zatek dku ?
         je        DispChr2                 ; je ji zatek dku
         dec       byte ptr ds:[Pozice+KORIG] ; snen pozice na dku
         jmp       short DispChr8           ; nastaven nov pozice

; ------ zobrazen znaku na displeji

DispChr4:mov       bx,word ptr ds:[Atrib+KORIG]; atributy a videostrnka
         mov       cx,1                     ; poet znak k zpisu
         mov       ah,9
         int       10h                      ; zpis znaku na pozici kurzoru
         inc       byte ptr ds:[Pozice+KORIG] ; zven pozice na dku
         mov       al,ds:[Pozice+KORIG]     ; pozice kurzoru
         cmp       al,ds:[Pozic+KORIG]      ; je dek ji pln ?
         jbe       DispChr8                 ; nen jet posledn pozice
         cmp       byte ptr ds:[Wrap+KORIG],0 ; je funkce WRAP ?
         je        DispChr5                 ; je funkce WRAP
         dec       byte ptr ds:[Pozice+KORIG] ; nvrat posledn pozice
         ret

DispChr5:mov       byte ptr ds:[Pozice+KORIG],0 ; nulovn pozice na dku
DispChr6:inc       byte ptr ds:[Radek+KORIG] ; zven ukazatele dku
         mov       al,ds:[MaxRadek+KORIG]   ; maximln dek displeje
         cmp       al,ds:[Radek+KORIG]      ; pekroen max. dek ?
         jae       DispChr8                 ; nen pekroen posledn dek
         mov       byte ptr ds:[Radek+KORIG],al ; omezen na posledn dek

; ------ rolovn displeje

DispChr7:mov       ax,0e0ah
         mov       bx,word ptr ds:[Atrib+KORIG] ; atributy a videostrnka
         int       10h                      ; posun o dek

; ------ zobrazen nov pozice kurzoru

DispChr8:mov       dx,word ptr ds:[Pozice+KORIG] ; dek a pozice
         mov       bh,ds:[AktPage+KORIG]    ; aktivn strnka displeje
         mov       ah,2
         int       10h                      ; nastaven pozice kurzoru
         ret

DispChr  ENDP

; -----------------------------------------------------------------------------
;        funkce 4 - ten ze zazen
; -----------------------------------------------------------------------------

FN04     PROC      NEAR

         jcxz      FN042                    ; nen poadovan dn bajt
FN041:   push      cs
         call      InpKey                   ; ten znaku
         pop       cx
         cld
         stosb                              ; uloen znaku do bufferu
         loop      FN041                    ; vstup dalho znaku
FN042:   jmp       Prerus3                  ; nvrat z funkce OK

FN04     ENDP

; -----------------------------------------------------------------------------
;        ten znaku ze zazen
; -----------------------------------------------------------------------------

InpKey   PROC      NEAR

         xor       ax,ax                    ; AL <- 0
         xchg      al,ds:[BuffKey+KORIG]    ; vyjmut znaku z bufferu
         or        al,al                    ; je pipraven znak ?
         jnz       InpKey3                  ; byl pipraven znak

InpKey1: int       16h                      ; vstup znaku z klvesnice BIOS
         or        ax,ax                    ; je klvesa Ctrl-Break ?
         jz        InpKey1                  ; klvesa Ctrl-Break se ignoruje

         or        al,al                    ; je speciln klvesa ?
         jnz       InpKey3                  ; nen dic klvesa
         mov       ds:[BuffKey+KORIG],ah    ; schova kdu klvesy
InpKey3: ret

InpKey   ENDP

; -----------------------------------------------------------------------------
;        funkce 5 - nedestruktivn ten ze zazen
; -----------------------------------------------------------------------------

FN05     PROC      NEAR

         mov       al,ds:[BuffKey+KORIG]    ; pipraven znak v bufferu
         or        al,al                    ; je pipraven dal znak ?
         jnz       FN052                    ; je pipraven znak - uloen znaku

         mov       ah,1
         int       16h                      ; test klvesnice
         jnz       FN051                    ; je njak znak OK
         jmp       Prerus1                  ; zazen nepipraveno

FN051:   or        ax,ax                    ; je Ctrl-Break ?
         jnz       FN052                    ; nen Ctrl-Break
         mov       ah,0
         int       16h                      ; zruen kdu Ctrl-Break z bufferu
         jmp       short FN05               ; nov test klvesnice

FN052:   lds       bx,ds:[Request+KORIG]    ; adresa zhlav poadavku
         mov       ds:[bx+0dh],al           ; uloen kdu ptho znaku
         jmp       Prerus3                  ; nvrat z funkce OK

FN05     ENDP

; -----------------------------------------------------------------------------
;        funkce 7 - vyprzdnn vstupu
; -----------------------------------------------------------------------------

FN07     PROC      NEAR

FN072:   mov       ah,1
         int       16h                      ; test znaku z klvesnice
         jz        FN073                    ; nen pipraven dn znak
         mov       ah,0
         int       16h                      ; zruen znaku z klvesnice
         jmp       short FN072              ; dal test

FN073:   mov       byte ptr ds:[BuffKey+KORIG],0 ; zruen znaku v bufferu
         jmp       Prerus3                  ; nvrat z funkce OK

FN07     ENDP

; -----------------------------------------------------------------------------
;        funkce 8, 9 - vstup na zazen
; -----------------------------------------------------------------------------

FN08     PROC      NEAR
FN09     PROC      NEAR

         jcxz      FN082
FN081:   mov       al,es:[di]               ; znak k zobrazen
         inc       di                       ; zven ukazatele v bufferu
         call      OutChr                   ; vstup znaku
         loop      FN081                    ; dal znak
FN082:   jmp       Prerus3                  ; nvrat z funkce OK

FN09     ENDP
FN08     ENDP

; -----------------------------------------------------------------------------
;        vstup znaku na konzolu
; -----------------------------------------------------------------------------

OutChr   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      es

; ------ pprava parametr displeje

         xor       cx,cx
         mov       es,cx                    ; ES <- 0
         mov       cl,es:[44ah]             ; poet pozic na dek
         mov       ch,es:[484h]             ; posledn dek
         cmp       ch,18
         jae       OutChr1
         mov       ch,24
OutChr1: mov       word ptr ds:[Pozic+KORIG],cx ; poet pozic a posledn dek

         mov       bl,es:[462h]             ; aktivn videostrnka
         mov       bh,0
         mov       ds:[AktPage+KORIG],bl    ; aktivn videostrnka
         shl       bx,1
         mov       bx,es:[bx+450h]          ; aktuln pozice kurzoru
         mov       word ptr ds:[Pozice+KORIG],bx ; aktuln pozice kurzoru

; ------ obsluha zobrazen znaku - adresa se MODIFIKUJE !!!!

OutChrM: call      TestEsc                  ; obsluha zobrazen

; ------ nvrat registr

         pop       es
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

OutChr   ENDP

; -----------------------------------------------------------------------------
;        skok na obsluhu zobrazen znaku
; -----------------------------------------------------------------------------

TestEsc  PROC      NEAR

         cmp       al,1bh                   ; je to znak ESC ?
         jne       TestEsc2                 ; nen to znak ESC
         mov       word ptr ds:[OutChrM+1],offset ESC1 ; obsluha znaku ESC
         ret

TestEsc2:call      DispChr                  ; zobrazen znaku
         mov       word ptr ds:[OutChrM+1],offset TestEsc ; potek k zobrazen
         ret

TestEsc  ENDP

; -----------------------------------------------------------------------------
;        obsluha prvnho znaku ESC
; -----------------------------------------------------------------------------

ESC1     PROC      NEAR

         cmp       al,"["
         jne       TestEsc2                 ; nen platn znak

         mov       word ptr ds:[OutChrM+1],ESC2 ; obsluha druhho znaku ESC
         xor       bx,bx
         mov       ds:[CitEsc],bx           ; ta znak ESC
         jmp       short ESC22

ESC1     ENDP

; -----------------------------------------------------------------------------
;        obsluha druhho znaku ESC
; -----------------------------------------------------------------------------

ESC2     PROC      NEAR

         cmp       al,";"
         jne       ESC23




;
;                                          ;* dal znaky po <ESC>[
;0360 3C3B         * CMP    AL,3B            ; je oddlova ";" ?
;0362 750C           JNZ    0370             ; nen oddlova ";"
;0364 FE060601   1  * INC    Byte Ptr [0106]  ; ta oddlova
;0368 E8D601     2  * CALL   0541             ; vpoet adresy v bufferu
;036B 33C0           XOR    AX,AX
;036D 8907           MOV    [BX],AX          ; uloen koncovho znaku 0
;036F C3             RET
;
;0370 3C30       3  * CMP    AL,30            ; je slice "0" ?
;0372 7212           JB     0386             ; nen platn slice
;0374 3C39           CMP    AL,39            ; je slice "9" ?
;0376 770E           JA     0386             ; nen platn slice
;0378 E8C601         CALL   0541             ; vpcet adresy v bufferu
;037B 2C30           SUB    AL,30            ; pevod na binrn slo
;037D 8607           XCHG   AL,[BX]          ; AL <- pvodn slo
;037F B40A           MOV    AH,0A            ; nsobek = 10
;0381 F6E4           MUL    AH               ; vynsoben 10*
;0383 0007           ADD    [BX],AL          ; piten k novmu sli
;0385 C3             RET
;
;0386 3C3D       4  * CMP    AL,3D            ; je znak "=" ?
;0388 7413           JZ     039D             ; je znak "=" - ignoruje se
;038A 3C3F           CMP    AL,3F            ; je znak "?" ?
;038C 740F           JZ     039D             ; je znak "?" - ignoruje se
;038E 3C22           CMP    AL,22            ; je znak " ?
;0390 7404           JZ     0396             ; bude nsledovat text
;0392 3C27           CMP    AL,27            ; je znak ' ?
;0394 7522           JNZ    03B8             ; nen znak '
;0396 C7049E03   5  * MOV    Word Ptr [SI],039E
;039A A20501         MOV    [0105],AL
;039D C3         6  * RET
;
;                                          ;* obsluha textu v uvozovkch
;039E 3A060501       CMP    AL,[0105]        ; je opt koncov znak ?
;03A2 7509           JNZ    03AD             ; nen koncov znak
;03A4 FE0E0601       DEC    Byte Ptr [0106]
;03A8 C7046003       MOV    Word Ptr [SI],0360 ; obsluha dalho znaku po ESC[
;03AC C3             RET
;
;03AD E89101       * CALL   0541             ; adresa v bufferu
;03B0 8807           MOV    [BX],AL          ; uloen znaku do textu
;03B2 C7049E03       MOV    Word Ptr [SI],039E ; pokraovn obsluhy textu
;03B6 EBAC           JMP    0364
;
;03B8 BB2700         MOV    BX,0027          ; tabulka posloupnost ESC
;03BB 83C303       * ADD    BX,+03           ; zven adresy v tabulce
;03BE 803F00         CMP    Byte Ptr [BX],00
;03C1 7425           JZ     03E8
;03C3 3807           CMP    [BX],AL
;03C5 75F4           JNZ    03BB
;03C7 8B4701         MOV    AX,[BX+01]
;03CA BB5B05         MOV    BX,055B
;03CD 43             INC    BX
;03CE 031EFB00       ADD    BX,[00FB]
;03D2 8A17           MOV    DL,[BX]
;03D4 32F6           XOR    DH,DH
;03D6 8BCA           MOV    CX,DX
;03D8 0BC9           OR     CX,CX
;03DA 7501           JNZ    03DD
;03DC 41             INC    CX
;03DD FFE0           JMP    AX
;
;
;
;                                          ;* posun pozice o CX dk/pozic
;03F2 3827         * CMP    [BX],AH          ; je dosaeno hranice ?
;03F4 7404           JZ     03FA             ; je dosaeno hranice
;03F6 0007           ADD    [BX],AL          ; posun pozice
;03F8 E2F8           LOOP   03F2             ; dal posun
;                                          ;* nvrat z funkce  - nov pozice
;03FA 8B160101     * MOV    DX,[0101]        ; nov pozice na displeji
;03FE 33DB           XOR    BX,BX            ; aktivn strnka = 0
;0400 B402           MOV    AH,02
;0402 CD10           INT    10               ; nastaven nov pozice na displeji
;0404 EBE5           JMP    03EB
;
;                                          ;* povely H, f - nastaven pozice
;0406 80F919         CMP    CL,19            ; je dek vy ne 25 ?
;0409 77EF           JA     03FA             ; dek je vy
;040B A00001         MOV    AL,[0100]        ; poet znak na dek
;040E 8A6F01         MOV    CH,[BX+01]       ; poadovan pozice
;0411 0AED           OR     CH,CH            ; je pozice ji = 0 ?
;0413 7402           JZ     0417             ; je ji 0
;0415 FECD           DEC    CH               ; pozice - 1
;0417 3AC5         * CMP    AL,CH            ; je pekroena max. pozice ?
;0419 7702           JA     041D             ; nen pekroena max. pozice
;041B 8AE8           MOV    CH,AL            ; omezen na max. pozici
;041D 86CD         * XCHG   CL,CH            ; CL<-pozice, CH<-dek
;041F FECD           DEC    CH               ; dek - 1
;0421 890E0101       MOV    [0101],CX        ; nastaven nov pozice displeje
;0425 EBD3           JMP    03FA             ; nastaven kurzoru
;
;                                          ;* povel C - posun o N pozic vpravo
;0427 8A260001       MOV    AH,[0100]        ; poet znak na dek
;042B B001           MOV    AL,01            ; posun o 1 znak vpravo
;042D BB0101       * MOV    BX,0101          ; adresa pozice
;0430 EBC0           JMP    03F2             ; nastaven nov pozice
;
;                                          ;* povel D - posun o N pozic vlevo
;0432 B8FF00         MOV    AX,00FF          ; min. pozice, posun vlevo
;0435 EBF6           JMP    042D
;
;                                          ;* povel A - posun o N dk nahoru
;0437 B8FF00         MOV    AX,00FF          ; pznak posunu nahoru
;043A BB0201       * MOV    BX,0102          ; adresa dku
;043D EBB3           JMP    03F2             ; proveden posunu
;
;                                          ;* povel B - posun o N dk dol
;043F B80118         MOV    AX,1801          ; pznak posunu dol
;0442 EBF6           JMP    043A             ; proveden posunu
;
;
;                                          ;* povel s - uloen kurzoru
;0444 A10101         MOV    AX,[0101]        ; souasn pozice kurzoru
;0447 A30301         MOV    [0103],AX        ; schova pozice kurzoru
;044A EBAE           JMP    03FA
;
;                                          ;* povel u - navrcen kurzoru
;044C A10301         MOV    AX,[0103]        ; uschovan pozice kurzoru
;044F A30101         MOV    [0101],AX        ; nastaven nov aktivn pozice
;0452 EBA6           JMP    03FA
;
;                                          ;* povel m - nastaven atribut
;0454 33C9           XOR    CX,CX
;0456 860E0601       XCHG   CL,[0106]        ; poet parametr v bufferu
;045A E8E400         CALL   0541             ; poskytnut adresy v bufferu
;045D 41             INC    CX               ; poet parametr + 1
;045E 8A07         * MOV    AL,[BX]          ; zadan parametr
;0460 53             PUSH   BX               ; schova adresy bufferu
;0461 BB5B00         MOV    BX,005B          ; tabulka atribut barev
;0464 8A27           MOV    AH,[BX]          ; slo atributu
;0466 83C303         ADD    BX,+03           ; zven adresy v tabulce
;0469 80FCFF         CMP    AH,FF            ; je ji konec tabulky ?
;046C 740F           JZ     047D             ; je konec tabulky
;046E 3AE0           CMP    AH,AL            ; je zadan kd povelu ?
;0470 75F2           JNZ    0464             ; nen zadan kd povelu
;0472 8B47FE         MOV    AX,[BX-02]       ; maskovac slovo povelu
;0475 20061501       AND    [0115],AL        ; maskovn AND
;0479 08261501       OR     [0115],AH        ; maskovn OR
;047D 5B           * POP    BX               ; adresa v tabulce parametr
;047E 43             INC    BX               ; zven ukazatele na dal param.
;047F E2DD           LOOP   045E             ; dal parametr
;0481 E976FF         JMP    03FA
;
;                                          ;* povel J - vymazn obrazovky
;0484 33C9           XOR    CX,CX
;0486 890E0101       MOV    [0101],CX        ; pozice do levho hornho rohu
;048A B619           MOV    DH,19            ; posledn dek (25)
;048C 8A160001     * MOV    DL,[0100]        ; posledn pozice displeje
;0490 8A3E1501       MOV    BH,[0115]        ; videostrnka
;0494 B80006         MOV    AX,0600          ; rolovn okna nahoru
;0497 CD10           INT    10               ; vymazn obrazovky
;0499 E95EFF         JMP    03FA
;
;                                          ;* povel K - zruen zbytku dku
;049C 8B0E0101       MOV    CX,[0101]        ; aktuln pozice kurzoru
;04A0 8AF5           MOV    DH,CH            ; dek s kurzorem
;04A2 EBE8           JMP    048C             ; vymazn zbytku dku
;
;
;                                          ;* pevod sla na 2 znaky ASCII
;04A4 B20A           MOV    DL,0A            ; konstanta k dlen
;04A6 FEC0           INC    AL               ; slo + 1
;04A8 32E4           XOR    AH,AH
;04AA F6F2           DIV    DL               ; pevod na 2 znaky
;04AC 053030         ADD    AX,3030          ; AH, AL=znaky sla
;04AF C3             RET
;
;                                          ;* povel n - dotaz na pozici
;
;04B0 A00201         MOV    AL,[0102]        ; aktuln dek na displeji
;04B3 E8EEFF         CALL   04A4             ; pevod na znaky ASCII
;04B6 A30D01         MOV    [010D],AX        ; znaky sla dku
;04B9 A00101         MOV    AL,[0101]        ; aktuln pozice na displeji
;04BC E8E5FF         CALL   04A4             ; pevod na znaky ASCII
;04BF A31001         MOV    [0110],AX        ; znaku sla pozice
;04C2 C606080109     MOV    Byte Ptr [0108],09 ; poet znak k vstupu = 9
;04C7 C70609010B01   MOV    Word Ptr [0109],010B ; adresa textu k vstupu
;                                          ;* povel R - vstup pozice kurzoru
;04CD E91BFF       * JMP    03EB             ; dn funkce
;
;
;                                          ;* povel l - vypnut funkce WRAP
;04D0 B101           MOV    CL,01            ; nov stav - vypnut WRAP
;04D2 EB02           JMP    04D6
;                                          ;* povel h - nastaven videomdu
;04D4 33C9           XOR    CX,CX            ; nov stav - zapnut WRAP
;04D6 8AC2         * MOV    AL,DL            ; poadovan videomd
;04D8 3C07           CMP    AL,07            ; je videomd vt ne 7 ?
;04DA 77F1           JA     04CD             ; chyba - neznm videomd
;04DC 7206           JB     04E4             ; je nastaven videomdu
;04DE 880EFA00       MOV    [00FA],CL        ; nastaven novho stavu WRAP
;04E2 EBE9           JMP    04CD             ; nvrat
;04E4 B400         * MOV    AH,00
;04E6 CD10           INT    10               ; nastaven novho videomdu
;04E8 EBE3           JMP    04CD             ; nvrat
;
;                                          ;* parametr p - pedefinovn klvesy
;
;04EA 33D2           XOR    DX,DX            ; DX <- 0
;04EC 86160601       XCHG   DL,[0106]        ; poet bajt v bufferu
;04F0 42             INC    DX
;04F1 42             INC    DX
;04F2 E84C00         CALL   0541             ; poskytnut adresy v bufferu
;04F5 8B07           MOV    AX,[BX]          ; znak
;04F7 E868FD         CALL   0262             ; nalezen klvesy v tabulce
;04FA 751B           JNZ    0517             ; klvesa nenalezena
;04FC 8BFB           MOV    DI,BX            ; adresa nalezen klvesy
;04FE 290EFB00       SUB    [00FB],CX        ; snen dlky tabulky klves
;0502 C606080100     MOV    Byte Ptr [0108],00 ; zruen bufferu klves
;0507 8BF7           MOV    SI,DI            ; adresa klvesy
;0509 03F1           ADD    SI,CX            ; adresa novho textu
;050B B92306         MOV    CX,0623          ; adresa konce bufferu
;050E 2BCE           SUB    CX,SI            ; dlka zbyl sti bufferu
;0510 FC             CLD                     ; smr penosu nahoru
;0511 06             PUSH   ES               ; schova ES
;0512 0E             PUSH   CS
;0513 07             POP    ES               ; ES <- CS
;0514 F3             REPZ
;0515 A4             MOVSB                   ; zruen klvesy z tabulky
;0516 07             POP    ES               ; nvrat ES
;0517 E82700       * CALL   0541             ; poskytnut adresy v bufferu
;051A 80FA03         CMP    DL,03            ; dlka zadn
;051D 7217           JB     0536             ; je mal dlka zadn
;051F 8857FF         MOV    [BX-01],DL       ; nastaven novho potu znak
;0522 0116FB00       ADD    [00FB],DX        ; zven dlky dat o klvesu
;0526 03DA           ADD    BX,DX            ; zven adresy v bufferu
;0528 813EFB00C800   CMP    Word Ptr [00FB],00C8 ; je ji pekroena max. dlka ?
;052E 7206           JB     0536             ; nen pekroena dlka bufferu
;0530 2BDA           SUB    BX,DX            ; nvrat pvodn pozice konce
;0532 2916FB00       SUB    [00FB],DX        ; nvrat pvodn dlky bufferu
;0536 C647FF00     * MOV    Byte Ptr [BX-01],00 ;
;053A C706FD00DF03   MOV    Word Ptr [00FD],03DF
;0540 C3             RET
;
;                                          ;* zjitn adresy v bufferu
;0541 8B1EFB00       MOV    BX,[00FB]        ; dlka dat v bufferu
;0545 43             INC    BX               ; prvn bajt za klvesami
;0546 031E0601       ADD    BX,[0106]        ; adres konce bufferu
;054A 81FBD000       CMP    BX,00D0          ; je pekroen konec buffeur ?
;054E 7206           JB     0556             ; nen pekroen konec bufferu
;0550 FE0E0601       DEC    Byte Ptr [0106]  ; snen tae znak
;0554 EBEB           JMP    0541             ; nov konec bufferu
;0556 81C35B05     * ADD    BX,055B
;055A C3             RET
;
;                                          ;* tabulka pro pekdovn znak
;
;055b               db        4,0,72h,10h
;                   db        0d0h-4 dup(0)
;
;
;
;







RezEnd   label     near                     ; konec rezidentn sti

; -----------------------------------------------------------------------------
;        start programu
; -----------------------------------------------------------------------------

; ------ zobrazen vodnho textu

Init:    mov       dx,offset UvTxt
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ pprava k dekdovn pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0

; ------ nalezen zadanho parametru

         cld
Init1:   jcxz      Init2                    ; nen dal znak
         lodsb
         dec       cx
         cmp       al," "
         je        Init1
         cmp       al,9
         je        Init1
         cmp       al,"/"
         je        Init1

; ------ zadn parametru "!"

         or        byte ptr ds:[Param],2    ; pznak odinstalovn
         cmp       al,"!"
         je        Init2                    ; je zadn parametr "!" - OK

; ------ chyba - zobrazen chybovho textu

         mov       dx,offset HelpTxt        ; text npovdy
Chyba:   mov       ah,9
         int       21h                      ; zobrazen chybovho textu
         int       20h

; ------ pesun programu dol

Init2:   mov       si,offset RezBeg         ; star zatek rezidentn sti
         mov       di,offset RezBeg + KORIG ; nov zatek rezidentn sti
         mov       cx,offset(RezEnd-RezBeg) ; dlka rezidentn sti
         cld
         rep       movsb                    ; posun programu dol

; ------ adresa zatku tabulek DOS

         mov       bx,-1                    ; pednastaven na zakzanou hodnotu
         mov       ah,52h
         int       21h                      ; tabulka DOS
         mov       dx,offset KompTxt        ; text - nekompatibiln systm
         mov       ax,cs
         mov       cx,es
         cmp       ax,cx
         je        Chyba                    ; sluba neobsluhovan

; ------ nalezen zazen NUL

         push      cs
         pop       ds                       ; DS <- CS (pro jistotu)
Init3:   inc       bx                       ; dal adresa
         jz        Chyba                    ; zazen NUL nenalezeno
         lea       di,[bx+0ah]              ; jmno zazen
         mov       si,offset NulDev         ; hledan text "NUL"
         mov       cx,8                     ; dlka textu k porovnn
         cld
         repe      cmpsb                    ; porovnn textu
         jne       Init3                    ; nen to zazen NUL
         mov       ax,es:[bx+4]             ; atributy zazen
         and       ax,801fh                 ; atributy
         cmp       ax,8004h                 ; je to zazen NUL ?
         jne       Init3                    ; nen to zazen NUL

; ------ nalezen zazen CON

         mov       bp,200                   ; maximln poet zazen
Init4:   dec       bp                       ; ta pokus
         jz        Chyba                    ; zazen nenalezeno
         mov       word ptr ds:[PredCon],bx ; adresa pedchozho zazen LOW
         mov       word ptr ds:[PredCon+2],es ; adresa pedchozho zazen HIGH
         les       bx,es:[bx]               ; adresa FAR dalho zazen
         mov       ax,es                    ; segment dalho zazen
         cmp       ax,bx                    ; je-li konec etzce, je FFFF:FFFF
         jne       Init5                    ; nen jet konec etzce zazen
         inc       ax                       ; je konec etzce zazen ?
         jz        Chyba                    ; konec - CON nenalezen
Init5:   lea       di,[bx+0ah]              ; jmno zazen
         mov       si,offset DevName+KORIG  ; hledan text "CON"
         mov       cx,8                     ; dlka textu k porovnn
         rep       cmpsb                    ; porovnn textu
         jne       Init4                    ; nen to zazen CON
         mov       ax,es:[bx+4]             ; atributy zazen
         and       ax,800fh                 ; atributy
         cmp       ax,8003h                 ; je to zazen CON ?
         jne       Init4                    ; nen to zazen CON
         mov       word ptr ds:[DevNext+KORIG],bx ; adresa zazen CON LOW
         mov       word ptr ds:[DevNext+KORIG+2],es ; adresa zazen CON HIGH

; ------ test, zda je instalovn tento program

         mov       si,offset IdentBeg+KORIG ; zatek identifikace
         mov       di,si
         mov       cx,offset(IdentEnd-IdentBeg) ; dlka k identifikaci
         cld
         repe      cmpsb                    ; porovnn vzorku programu
         jne       Init7                    ; program nesouhlas
         or        byte ptr ds:[Param],1    ; pznak nainstalovn programu

; ------ test, zda m bt program odinstalovn

Init7:   test      byte ptr ds:[Param],2    ; je poadovno odinstalovn ?
         jnz       Init8                    ; odinstalovn programu

; ------ test, zda je ji nainstalovn v pamti

         test      byte ptr ds:[Param],1    ; je ji nainstalovn v pamti ?
         jz        Init72                   ; nen jet nainstalovn
         mov       dx,offset JeInsTxt       ; text - je ji nainstalovn
Chyba2:  jmp       Chyba                    ; chyba

; ------ hlen o nainstalovn programu

Init72:  mov       dx,offset InstTxt        ; text - byl nainstalovn
         mov       ah,9
         int       21h                      ; zobrazen hlen o instalaci

; ------ schova adresy INT 29h

         cli
         mov       ax,3529h
         int       21h
         mov       word ptr ds:[Old29+KORIG],bx
         mov       word ptr ds:[Old29+2+KORIG],es

; ------ schova adresy INT 1bh

         mov       ax,351bh
         int       21h
         mov       word ptr ds:[Old1b+KORIG],bx
         mov       word ptr ds:[Old1b+KORIG],es

; ------ instalace obsluhy INT 29h

         mov       dx,offset INT29+KORIG
         mov       ax,2529h
         int       21h                      ; instalace INT 29h

; ------ instalace obsluhy INT 1Bh

         mov       dx,offset INT1B+KORIG
         mov       ax,251bh
         int       21h                      ; instalace INT 1Bh

; ------ nastaven nvaznosti z pedelho zazen

         les       bx,ds:[PredCon]          ; adresa pedelho zazen
         mov       word ptr es:[bx],offset DevNext+KORIG ; offs. tohoto zazen
         mov       es:[bx+2],cs             ; segment tohoto zazen

; ------ uvolnn segmentu prosted

         mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h
         int       21h                      ; uvolnn segmentu prosted

; ------ instalace programu do pamti

         mov       dx,offset RezEnd+KORIG   ; konec rezidentn sti
         int       27h                      ; instalace programu do pamti

; ------ progrm m bt odinstalovn - test, zda je nainstalovn

Init8:   mov       dx,offset NeniTxt        ; text - nen nainstalovn
         test      byte ptr ds:[Param],1    ; je program nainstalovn ?
         jz        Chyba2                   ; chyba - nen nainstalovn

; ------ test, zda lze program odinstalovat

         mov       dx,offset NelzeTxt       ; text - nelze odinstalovat
         mov       ax,351bh
         int       21h                      ; adresa INT 1Bh
         mov       ax,es
         cmp       ax,word ptr ds:[DevNext+2+KORIG]  ; souhlas segm. INT 1Bh ?
         jne       Chyba2                   ; nesouhlas
         mov       ax,3529h
         int       21h                      ; adresa INT 29h
         mov       ax,es
         cmp       ax,word ptr ds:[DevNext+2+KORIG]  ; souhlas segm. INT 29h ?
         jne       Chyba2                   ; nesouhlas

; ------ nvrat adresy INT 1Bh

         cli
         mov       es,word ptr ds:[DevNext+2+KORIG]
         lds       dx,es:[Old1B+KORIG]      ; pvodn adresa INT 1Bh
         mov       ax,251bh
         int       21h                      ; nvrat adresy INT 1Bh

; ------ nvrat adresy INT 29h

         lds       dx,es:[Old29+KORIG]      ; pvodn adresa INT 29h
         mov       ax,2529h
         int       21h                      ; nvrat adresy INT 29h

; ------ nvrat nvaznosti zazen

         mov       ax,word ptr es:[DevNext+KORIG] ; offset dalho zazen
         mov       cx,word ptr es:[DevNext+KORIG+2] ; segment dalho zazen
         lds       bx,cs:[PredCon]          ; adresa pedelho zazen
         mov       ds:[bx],ax               ; nvrat offsetu zazen
         mov       ds:[bx+2],cx             ; nvrat segmentu zazen

; ------ uvolnn segmentu programu

         mov       ah,49h
         int       21h                      ; uvolnn segmentu programu

; ------ hlen o odinstalovn programu z pamti

         push      cs
         pop       ds
         mov       dx,offset DInsTxt
         jmp       Chyba

; -----------------------------------------------------------------------------
;        data
; -----------------------------------------------------------------------------

UvTxt    db        'ANSI V1.0 - ovladac displeje ANSI; (c) Miroslav Nemecek',13,10,'$'
HelpTxt  db        'Zadejte:  ! .... odinstalovani programu z pameti.',13,10,'$'
KompTxt  db        'Nekompatibilni operacni system - program NENAINSTALOVAN !',13,10,'$'

JeInsTxt db        'Program je jiz nainstalovan v pameti ...',13,10,'$'
InstTxt  db        ' Program byl nainstalovan do pameti.',13,10,'$'
NelzeTxt db        'Program nelze odinstalovat z pameti !',13,10,'$'
NeniTxt  db        'Program nelze odinstalovat, nebyl dosud nainstalovan !',13,10,'$'
DInsTxt  db        'Program byl odinstalovan z pameti.',13,10,'$'

NulDev   db        'NUL     '
PredCon  dd        0                        ; adresa pedchozho zazen
Param    db        0                        ; parametry
                                            ;   bit 0: 1=program je nainstalovn
                                            ;   bit 1: 1=poadavek odinstalovn

Code     ENDS
         END       Start


; *****************************************************************************
;
;                  Roziujc driver konzoly ANSI.SYS
;
; *****************************************************************************

         dd        -1
         dw        8013h                    ; atributy
         dw        00a2h
         dw        00adh
         db        'CON     '

0012     dw        062bh                    ; 0 inicializace zazen
0014     dw        00deh                    ; 1 kontrola mdia (OK)
0016     dw        00deh                    ; 2 vystavn bloku BPB (OK)
0018     dw        00d8h                    ; 3 vstup kanlu IOCTL (chyba)
001a     dw        0200h                    ; 4 vstup (ten ze zazen)
001c     dw        0282h                    ; 5 nedestruktivn vstup
001e     dw        00deh                    ; 6 statut vstupu (OK)
0020     dw        02c6h                    ; 7 vyprzdnn vstupu
0022     dw        02deh                    ; 8 vstup (zpis na zazen)
0024     dw        02deh                    ; 9 vstup s verifikac
0026     dw        00deh                    ; 10 statut vstupu (OK)
0028     dw        00deh                    ; 11 vyprzdnn vstupu (OK)


                                          ;* tabulka posloupnost ESC[
002a               db        'A'
                   dw        0437h
002d               db        'B'
                   dw        043fh
0030               db        'C'
                   dw        0427h
0033               db        'D'
                   dw        0432h
0036               db        'H'
                   dw        0406h
0039               db        'J'
                   dw        0484h
003c               db        'K'
                   dw        049ch
003f               db        'R'
                   dw        04cdh
0042               db        'f'
                   dw        0406h
0045               db        'h'
                   dw        04d4h
0048               db        'l'
                   dw        04d0h
004b               db        'm'
                   dw        0454h
004e               db        'n'
                   dw        04b0h
0051               db        'p'
                   dw        04eah
0054               db        's'
                   dw        0444h
0057               db        'u'
                   dw        044ch
005a               db        0


005b                                      ;* tabulka atribut barev znak
                   db        0,0,7          ; 0: AND 00, OR 07
                   db        1,0ffh,8       ; 1: AND FF, OR 08
                   db        4,0f8h,1       ; 4: AND F8, OR 01
                   db        5,0ffh,80h     ; 5: AND FF, OR 80
                   db        7,0f8h,70h     ; 7: AND F8, OR 70
                   db        8,88h,0        ; 8: AND 88, OR 00
                   db        30,0f8h,0      ; 30: AND F8, OR 0
                   db        31,0f8h,4



0030  43 27 04 44 32 04 48 06-04 4A 84 04 4B 9C 04 52  C'.D2.H..J..K..R
0040  CD 04 66 06 04 68 D4 04-6C D0 04 6D 54 04 6E B0  M.f..hT.lP.mT.n0
0050  04 70 EA 04 73 44 04 75-4C 04 00 00 00 07 01 FF  .pj.sD.uL.......
0060  08 04 F8 01 05 FF 80 07-F8 70 08 88 00 1E F8 00  ..x.....xp....x.
0070  1F F8 04 20 F8 02 21 F8-06 22 F8 01 23 F8 05 24  .x. x.!x."x.#x.$
0080  F8 03 25 F8 07 28 8F 00-29 8F 40 2A 8F 20 2B 8F  x.%x.(..).@*. +.
0090  60 2C 8F 10 2D 8F 50 2E-8F 30 2F 8F 70 FF 00 00  `,..-.P..0/.p...
00A0  00 00 2E 89 1E 9E 00 2E-8C 06 A0 00 CB 56 50 51  .......... .KVPQ


; -----------------------------------------------------------------------------
009e               dd        0              ; adresa poadavku zazen

                                          ;* obsluha rutiny strategie
00A2 2E891E9E00     MOV    CS:[009E],BX     ; uloen offsetu adresy poadavku
00A7 2E8C06A000     MOV    CS:[00A0],ES     ; uloen segmentu adresu poadavku
00AC CB             RETF

; -----------------------------------------------------------------------------
                                          ;* obsluha rutiny peruen
00AD 56             PUSH   SI
00AE 50             PUSH   AX
00AF 51             PUSH   CX
00B0 52             PUSH   DX
00B1 57             PUSH   DI
00B2 55             PUSH   BP
00B3 1E             PUSH   DS
00B4 06             PUSH   ES
00B5 53             PUSH   BX
00B6 2EC51E9E00     LDS    BX,CS:[009E]     ; adresa poadavku zazen
00BB 8B4F12         MOV    CX,[BX+12]       ; poet bajt pro penos
00BE 8A4702         MOV    AL,[BX+02]       ; kd poadovanho povelu
00C1 98             CBW                     ; AX <- AL
00C2 BE1200         MOV    SI,0012          ; adresa tabulky adres obsluh
00C5 03F0           ADD    SI,AX
00C7 03F0           ADD    SI,AX            ; adresa v tabulce
00C9 3C0B           CMP    AL,0B            ; je slo funkce > 11 ?
00CB 770B           JA     00D8             ; je chybn slo funkce
00CD C47F0E         LES    DI,[BX+0E]       ; adresa bufferu
00D0 0E             PUSH   CS
00D1 1F             POP    DS               ; DS <- CS
00D2 FF24           JMP    [SI]             ; skok na obsluhu funkce

00D4 B403           MOV    AH,03            ; pznak - zazen nen pipraveno
00D6 EB08           JMP    00E0

                                          ;* chybn slo funkce
00D8 B003         * MOV    AL,03            ; chyba - neznm povel
00DA B481           MOV    AH,81            ; pznak chyby
00DC EB02           JMP    00E0

                                          ;* nvrat z funkce OK
00DE B401           MOV    AH,01            ; pznak - akce provedena
00E0 2EC51E9E00   * LDS    BX,CS:[009E]     ; adresa zhlav poadavku
00E5 894703         MOV    [BX+03],AX       ; uloen chybovho kdu
00E8 5B             POP    BX
00E9 07             POP    ES
00EA 1F             POP    DS
00EB 5D             POP    BP
00EC 5F             POP    DI
00ED 5A             POP    DX
00EE 59             POP    CX
00EF 58             POP    AX
00F0 5E             POP    SI
00F1 CB             RETF
; -----------------------------------------------------------------------------
                                          ;* vlastn obsluha INT 1Bh
00F2 2EC606140103   MOV    Byte Ptr CS:[0114],03
00F8 90             NOP
00F9 CF             IRET

00fa               db        0              ; 0=je funkce WRAP
00fb               dw        4              ; dlka tabulky klves
00fd               dw        03dfh          ; adresa obsluhy vstupu znaku
00ff               db        3              ; standardn videomd
0100               db        79             ; poet znak na dek
0101               dw        0              ; aktuln pozice kurzoru
0103               dw        0              ; uschovan pozice kurzoru
0105               db        0              ; schova znaku textu "'
0106               db        0              ; poet parametr v bufferu ESC
0107               db        0
0108               db        0              ; poet znak v bufferu
0109               dw        055bh          ; ukazatel textu v bufferu
                                          ;* vstupn text - informace o pozici
010b               db        27,'['
010d               db        '00;'          ; aktuln dek
0110               db        '00R',13       ; aktuln pozice

0114               db        0              ; uschovan kd znaku (3=^C)
0115               db        7              ; atributy pro zobrazen
0116               db        0              ; aktivn strnka displeje
0117               dw        0b800h         ; segment adresy videopamti
0119               dw        0              ; offset videostrnky (v odstavcch)


00E0  2E C5 1E 9E 00 89 47 03-5B 07 1F 5D 5F 5A 59 58  .E....G.[..]_ZYX
00F0  5E CB 2E C6 06 14 01 03-90 CF 00 04 00 DF 03 03  ^K.F.....O..._..
0100  4F 00 00 00 00 00 00 00-00 5B 05 1B 5B 30 30 3B  O........[..[00;
0110  30 30 52 0D 00 07 00 00-B8 00 00 3C 0D 75 07 C6  00R.....8..<.u.F
0120  06 01 01 00 EB 61 3C 0A-74 4A 3C 07 75 0C 8B 1E  ....ka<.tJ<.u...

                                          ;* zobrazen znaku na displej BIOS
011B 3C0D           CMP    AL,0D            ; je znak <CR> ?
011D 7507           JNZ    0126             ; nen znak <CR>
011F C606010100     MOV    Byte Ptr [0101],00 ; vynulovn pozice na displeji
0124 EB61           JMP    0187             ; nastaven nov pozice kurzoru
0126 3C0A         * CMP    AL,0A            ; je znak <LF> ?
0128 744A           JZ     0174             ; je <LF> - posun o dek dol
012A 3C07           CMP    AL,07            ; je znak <BEL> ?
012C 750C           JNZ    013A             ; nen znak <BEL>
                                          ;* vstup znaku
012E 8B1E1501       MOV    BX,[0115]        ; atributy a videostrnka
0132 80E307         AND    BL,07            ; atributy pro zobrazen
0135 B40E           MOV    AH,0E            ; funkce vstupu znaku
0137 CD10           INT    10               ; vstup znaku na displej
0139 C3           * RET

013A 3C08           CMP    AL,08            ; je znak <BS> ?
013C 750D           JNZ    014B             ; nen znak <BS>
013E 803E010100     CMP    Byte Ptr [0101],00 ; je ji zatek dku ?
0143 74F4           JZ     0139             ; je ji zatek dku
0145 FE0E0101       DEC    Byte Ptr [0101]  ; snen pozice na displeji
0149 EB3C           JMP    0187             ; nastaven nov pozice na displeji
                                          ;* zobrazen znaku na displeji
014B 8B1E1501     * MOV    BX,[0115]        ; atributy a videostrnka
014F B90100         MOV    CX,0001          ; poe znak k zpisu = 1
0152 B409           MOV    AH,09            ; funkce zobrazen znaku
0154 CD10           INT    10               ; zpis znaku na pozici kurzoru
0156 FE060101       INC    Byte Ptr [0101]  ; zven pozice kurzoru
015A A00101         MOV    AL,[0101]        ; pozice kurzoru
015D 3A060001       CMP    AL,[0100]        ; je ji posledn pozice na dku ?
0161 7624           JBE    0187             ; nen jet posledn pozice
0163 803EFA0000     CMP    Byte Ptr [00FA],00 ; je funkce WRAP ?
0168 7405           JZ     016F             ; je funkce WRAP
016A FE0E0101       DEC    Byte Ptr [0101]  ; nvrat posledn pozice na dku
016E C3             RET

016F C606010100   * MOV    Byte Ptr [0101],00 ; vynulovn pozice na dku
                                          ;* posun o dek dol
0174 FE060201     * INC    Byte Ptr [0102]  ; zven dku na displeji
0178 803E020119     CMP    Byte Ptr [0102],19 ; je pekroen dek 25 ?
017D 7208           JB     0187             ; nen pekroen dek 25
017F C606020118     MOV    Byte Ptr [0102],18 ; nastaven dku 24
0184 E81100         CALL   0198             ; rolovn
                                          ;* nastaven nov pozice kurzoru
0187 8A360201     * MOV    DH,[0102]        ; dek kurzoru
018B 8A160101       MOV    DL,[0101]        ; pozice na dku
018F 8A3E1601       MOV    BH,[0116]        ; aktivn strnka displeje
0193 B402           MOV    AH,02            ; funkce nastaven kurzoru
0195 CD10           INT    10               ; nastaven pozice kurzoru
0197 C3             RET

                                          ;* rolovn obrazovky
0198 A0FF00         MOV    AL,[00FF]        ; nastaven videomd
019B 3C02           CMP    AL,02            ; je videomd 2 (80x25) ?
019D 7408           JZ     01A7             ; je videomd 2
019F 3C03           CMP    AL,03            ; je videomd 3 ?
01A1 7404           JZ     01A7             ; je videomd 3
01A3 B00A           MOV    AL,0A            ; znak <LF>
01A5 EB87           JMP    012E             ; posun o dek pomoc BIOS

                                          ;* vlastn rolovn displeje
01A7 8A3E1501     * MOV    BH,[0115]        ; atributy pro zobrazen
01AB B320           MOV    BL,20            ; znak mezery pro doplnn
01AD BD5000         MOV    BP,0050          ; poet znak na dek = 80
01B0 A11701         MOV    AX,[0117]        ; segment videopamti
01B3 03061901       ADD    AX,[0119]        ; adresa videostrnky
01B7 8EC0           MOV    ES,AX            ; segment videostrnky
01B9 8ED8           MOV    DS,AX            ; segment videostrnky
01BB 33FF           XOR    DI,DI            ; adresa zatku pro rolovn
01BD BEA000         MOV    SI,00A0          ; adresa druhho dku
01C0 B98007         MOV    CX,0780          ; poet znak k pesunu
01C3 FC             CLD                     ; smr pesunu nahoru
01C4 2E813E170100B8 CMP    Word Ptr CS:[0117],B800 ; je displej EGA/CGA ?
01CB 740B           JZ     01D8             ; je EGA/CGA
01CD F3             REPZ
01CE A5             MOVSW                   ; pesun dat displeje
01CF 8BC3           MOV    AX,BX            ; mazac znak
01D1 8BCD           MOV    CX,BP            ; dlka spodnho dku
01D3 F3             REPZ
01D4 AB             STOSW                   ; vymazn spodnho dku
01D5 0E           * PUSH   CS
01D6 1F             POP    DS               ; DS <- CS
01D7 C3             RET                     ; nvrat

                                          ;* rolovn displeje CGA,EGA
01D8 B80280         MOV    AX,8002          ; (obsluha MICROSOFT NETWORKS)
01DB CD2A           INT    2A               ; hlen kritick sekce DOS slo 2
01DD BADA03         MOV    DX,03DA          ; stavov registr CGA
01E0 EC           * IN     AL,DX            ; ten stavovho registru CGA
01E1 A808           TEST   AL,08            ; probh vertikln synchron. ?
01E3 74FB           JZ     01E0             ; neprobh vert. synchr.
01E5 B025           MOV    AL,25
01E7 BAD803         MOV    DX,03D8
01EA EE             OUT    DX,AL            ; vypnut displeje
01EB F3             REPZ
01EC A5             MOVSW                   ; rolovn textu
01ED 8BC3           MOV    AX,BX
01EF 8BCD           MOV    CX,BP
01F1 F3             REPZ
01F2 AB             STOSW                   ; vymazn spodnho dku
01F3 B029           MOV    AL,29
01F5 BAD803         MOV    DX,03D8
01F8 EE             OUT    DX,AL            ; zapnut displeje
01F9 B80281         MOV    AX,8102
01FC CD2A           INT    2A               ; hlen konce kritick sekce 2
01FE EBD5           JMP    01D5             ; nvrat

; ---------------------------- FUNKCE 04 --------------------------------------
                                          ;* vstup ze zazen (ten)

0200 E308           JCXZ   020A             ; nen poadovan dn bajt
0202 51           * PUSH   CX
0203 E80700         CALL   020D             ; ten znaku
0206 59             POP    CX
0207 AA             STOSB                   ; uloen znaku do bufferu
0208 E2F8           LOOP   0202             ; vstup dalho znaku
020A E9D1FE       * JMP    00DE             ; nvrat z funkce

                                          ;* vstup znaku ze zazen
020D 33C0           XOR    AX,AX            ; AX <- 0
020F 86061401       XCHG   AL,[0114]        ; uschovan kd znaku
0213 0AC0           OR     AL,AL            ; je pipraven znak ?
0215 7531           JNZ    0248             ; byl pipraven znak
0217 803E080100   * CMP    Byte Ptr [0108],00 ; je njak text v bufferu ?
021C 751B           JNZ    0239             ; v bufferu je njak text
021E 32E4           XOR    AH,AH            ; funkce vstupu z klvesnice
0220 CD16           INT    16               ; ten znaku z klvesnice BIOS
0222 E83D00         CALL   0262             ; nalezen klvesy v tabulce
0225 7515           JNZ    023C             ; klvesa nebyla nalezena v bufferu
0227 49             DEC    CX
0228 49             DEC    CX
0229 43             INC    BX
022A 43             INC    BX
022B 0AC0           OR     AL,AL            ; je speciln klvesa ?
022D 7502           JNZ    0231             ; nen speciln klvesa
022F 49             DEC    CX               ; snen potu znak
0230 43             INC    BX               ; zven ukazatele v tabulce
0231 880E0801     * MOV    [0108],CL        ; poet znak v bufferu
0235 891E0901       MOV    [0109],BX        ; adresa textu v bufferu
0239 E80D00       * CALL   0249             ; vstup znaku z bufferu
023C 0BC0         * OR     AX,AX            ; je platn klvesa ?
023E 74D7           JZ     0217             ; nen platn klvesa - dal znak
0240 0AC0           OR     AL,AL            ; je speciln klvesa ?
0242 7504           JNZ    0248             ; nen speciln klvesa
0244 88261401       MOV    [0114],AH        ; uschovn kdu klvesy
0248 C3           * RET

                                          ;* vstup znaku z bufferu

0249 8B1E0901       MOV    BX,[0109]        ; adresa textu v bufferu
024D 8B07           MOV    AX,[BX]          ; znak k vstupu
024F FE0E0801       DEC    Byte Ptr [0108]  ; snen tae znak
0253 43             INC    BX               ; zven adresy v bufferu
0254 0AC0           OR     AL,AL            ; je to speciln klvesa ?
0256 7505           JNZ    025D             ; nen to speciln klvesa
0258 43             INC    BX               ; dal zven adresy
0259 FE0E0801       DEC    Byte Ptr [0108]  ; dal snen tae znak
025D 891E0901     * MOV    [0109],BX        ; nov adresa v bufferu
0261 C3             RET

                                          ;* nalezen klvesy v tabulce

0262 BB5B05         MOV    BX,055B
0265 8A0F         * MOV    CL,[BX]
0267 32ED           XOR    CH,CH
0269 0BC9           OR     CX,CX
026B 7412           JZ     027F
026D 0AC0           OR     AL,AL
026F 7505           JNZ    0276
0271 3B4701         CMP    AX,[BX+01]
0274 EB03           JMP    0279
0276 3A4701       * CMP    AL,[BX+01]
0279 7406         * JZ     0281
027B 03D9           ADD    BX,CX
027D EBE6           JMP    0265
027F 0BDB         * OR     BX,BX
0281 C3           * RET

; ------------------------------ FUNKCE 05 ------------------------------------
                                          ;* nedestruktivn vstup ze zazen

0282 A01401       * MOV    AL,[0114]        ; uschovan kd klvesy
0285 0AC0           OR     AL,AL            ; je pipraven dal znak ?
0287 7530           JNZ    02B9             ; je pipraven dal znak
0289 803E080100     CMP    Byte Ptr [0108],00 ; je njak text v bufferu ?
028E 7408           JZ     0298             ; v bufferu nen dn znak
0290 8B1E0901       MOV    BX,[0109]        ; adresa znaku v bufferu
0294 8A07           MOV    AL,[BX]          ; pipraven znak
0296 EB21           JMP    02B9             ; nvrat
                                          ;* test vstupu z klvesnice
0298 B401         * MOV    AH,01
029A CD16           INT    16               ; pipraven znak z klvesnice
029C 7425           JZ     02C3             ; zazen nen pipraveno
029E 0BC0           OR     AX,AX            ; kd pipraven klvesy
02A0 7506           JNZ    02A8             ; je normln kd klvesy
02A2 B400           MOV    AH,00
02A4 CD16           INT    16               ; zruen kdu 0000 z bufferu
02A6 EBDA           JMP    0282             ; nov vstup do funkce
                                          ;* nalezen klvesy v bufferu
02A8 E8B7FF       * CALL   0262             ; nalezen klvesy v bufferu
02AB 750C           JNZ    02B9             ; klvesa nebyla nalezena
02AD 8A4702         MOV    AL,[BX+02]       ; kd prvn klvesy
02B0 807F0100       CMP    Byte Ptr [BX+01],00 ; je to
02B4 7503           JNZ    02B9
02B6 8A4703         MOV    AL,[BX+03]       ; kd klvesy

02B9 C51E9E00     * LDS    BX,[009E]        ; adresa zhlav poadavku
02BD 88470D         MOV    [BX+0D],AL       ; uloen kdu ptho znaku

02C0 E91BFE         JMP    00DE             ; nvrat z funkce (OK)

02C3 E90EFE         JMP    00D4             ; nvrat - zazen nen pipraveno

; ---------------------------- FUNKCE 07 --------------------------------------
                                          ;* vyprzdnn vstupu

02C6 C606140100     MOV    Byte Ptr [0114],00 ; zruen pipravenho znaku
02CB C606080100     MOV    Byte Ptr [0108],00 ; zruen znaku z bufferu
02D0 B401         * MOV    AH,01
02D2 CD16           INT    16               ; test pipravenosti klvesnice
02D4 7406           JZ     02DC             ; klvesnice nen pipravena
02D6 B400           MOV    AH,00
02D8 CD16           INT    16               ; ten pipravenho znaku
02DA EBF4           JMP    02D0             ; vyprzdnn dalho znaku
02DC EBE2         * JMP    02C0             ; nvrat z funkce (OK)

; -------------------------- FUNKCE 08, 09 ------------------------------------
                                          ;* vstup na zazen

02DE E3E0           JCXZ   02C0             ; nvrat z funkce (OK)
02E0 268A05         MOV    AL,ES:[DI]       ; znak k vstupu
02E3 47             INC    DI               ; zven adresy v bufferu
02E4 E80D00         CALL   02F4             ; vstup znaku na konzolu
02E7 E2F7           LOOP   02E0             ; dal znak k vstupu
02E9 EBD5           JMP    02C0             ; nvrat z funkce (OK)

                                          ;* vlastn obsluha INT 29h
02EB FB             STI                     ; povolen peruen
02EC 1E             PUSH   DS               ; schova DS
02ED 0E             PUSH   CS
02EE 1F             POP    DS               ; DS <- CS
02EF E80200         CALL   02F4             ; vstup znaku na konzolu
02F2 1F             POP    DS               ; nvrat DS
02F3 CF             IRET

                                          ;* vstup znaku na konzolu
02F4 50             PUSH   AX
02F5 53             PUSH   BX
02F6 51             PUSH   CX
02F7 52             PUSH   DX
02F8 56             PUSH   SI
02F9 57             PUSH   DI
02FA 06             PUSH   ES
02FB 55             PUSH   BP
02FC C706170100B8   MOV    Word Ptr [0117],B800 ; segment videopamti
0302 96             XCHG   AX,SI            ; schova znaku k vstupu
0303 B84000         MOV    AX,0040          ; datov segment BIOS
0306 8ED8           MOV    DS,AX            ; DS <- 0040h
0308 A14900         MOV    AX,[0049]        ; souasn nastaven videomd
030B FECC           DEC    AH               ; posledn pozice na displeji
030D 2EA3FF00       MOV    CS:[00FF],AX     ; nastaven videomdu a ky adku
0311 3C07           CMP    AL,07            ; je videomd 7 (MDA) ?
0313 7507           JNZ    031C             ; nen videomd 7
0315 2EC706170100B0 MOV    Word Ptr CS:[0117],B000 ; segment VRAM pro kartu MDA
031C A06200       * MOV    AL,[0062]        ; aktivn strnka displeje
031F 2EA21601       MOV    CS:[0116],AL     ; schova aktivn strnky displeje
0323 98             CBW                     ; AX <- AL aktivn strnka displeje
0324 03C0           ADD    AX,AX            ; strnka * 2
0326 8BD8           MOV    BX,AX            ; BX <- strnka * 2
0328 8B4750         MOV    AX,[BX+50]       ; souasn pozice kurzoru na strnce
032B 2EA30101       MOV    CS:[0101],AX     ; schova pozice kurzoru
032F A14E00         MOV    AX,[004E]        ; poten adresa bufferu displeje
0332 B104           MOV    CL,04
0334 D3E8           SHR    AX,CL            ; pepoet adresy na odstavce
0336 0E             PUSH   CS
0337 1F             POP    DS               ; DS <- CS
0338 A31901         MOV    [0119],AX        ; offset videostrnky (v odstavcch)
033B 96             XCHG   AX,SI            ; SI<-offset videostr., AX<-znak
033C E80900         CALL   0348             ; zobrazen znaku
033F 5D             POP    BP
0340 07             POP    ES
0341 5F             POP    DI
0342 5E             POP    SI
0343 5A             POP    DX
0344 59             POP    CX
0345 5B             POP    BX
0346 58             POP    AX
0347 C3             RET


0348 BEFD00       * MOV    SI,00FD
034B FF24           JMP    [SI]             ; skok na zobrazen znaku


                                          ;* obsluha po znaku <ESC>
034D 3C5B           CMP    AL,5B            ; je znak "[" ?
034F 7403           JZ     0354             ; je znak "["
0351 E98B00         JMP    03DF             ; je vstup prvnho znaku
                                          ;* byl znak "["
0354 C7046003     * MOV    Word Ptr [SI],0360 ; obsluha po <ESC>[
0358 33DB           XOR    BX,BX
035A 891E0501       MOV    [0105],BX        ; ta znak po <ESC>[
035E EB08           JMP    0368

                                          ;* dal znaky po <ESC>[
0360 3C3B         * CMP    AL,3B            ; je oddlova ";" ?
0362 750C           JNZ    0370             ; nen oddlova ";"
0364 FE060601     * INC    Byte Ptr [0106]  ; ta oddlova
0368 E8D601       * CALL   0541             ; vpoet adresy v bufferu
036B 33C0           XOR    AX,AX
036D 8907           MOV    [BX],AX          ; uloen koncovho znaku 0
036F C3             RET

0370 3C30         * CMP    AL,30            ; je slice "0" ?
0372 7212           JB     0386             ; nen platn slice
0374 3C39           CMP    AL,39            ; je slice "9" ?
0376 770E           JA     0386             ; nen platn slice
0378 E8C601         CALL   0541             ; vpcet adresy v bufferu
037B 2C30           SUB    AL,30            ; pevod na binrn slo
037D 8607           XCHG   AL,[BX]          ; AL <- pvodn slo
037F B40A           MOV    AH,0A            ; nsobek = 10
0381 F6E4           MUL    AH               ; vynsoben 10*
0383 0007           ADD    [BX],AL          ; piten k novmu sli
0385 C3             RET

0386 3C3D         * CMP    AL,3D            ; je znak "=" ?
0388 7413           JZ     039D             ; je znak "=" - ignoruje se
038A 3C3F           CMP    AL,3F            ; je znak "?" ?
038C 740F           JZ     039D             ; je znak "?" - ignoruje se
038E 3C22           CMP    AL,22            ; je znak " ?
0390 7404           JZ     0396             ; bude nsledovat text
0392 3C27           CMP    AL,27            ; je znak ' ?
0394 7522           JNZ    03B8             ; nen znak '
0396 C7049E03     * MOV    Word Ptr [SI],039E
039A A20501         MOV    [0105],AL
039D C3           * RET

                                          ;* obsluha textu v uvozovkch
039E 3A060501       CMP    AL,[0105]        ; je opt koncov znak ?
03A2 7509           JNZ    03AD             ; nen koncov znak
03A4 FE0E0601       DEC    Byte Ptr [0106]
03A8 C7046003       MOV    Word Ptr [SI],0360 ; obsluha dalho znaku po ESC[
03AC C3             RET

03AD E89101       * CALL   0541             ; adresa v bufferu
03B0 8807           MOV    [BX],AL          ; uloen znaku do textu
03B2 C7049E03       MOV    Word Ptr [SI],039E ; pokraovn obsluhy textu
03B6 EBAC           JMP    0364

03B8 BB2700         MOV    BX,0027          ; tabulka posloupnost ESC
03BB 83C303       * ADD    BX,+03           ; zven adresy v tabulce
03BE 803F00         CMP    Byte Ptr [BX],00
03C1 7425           JZ     03E8
03C3 3807           CMP    [BX],AL
03C5 75F4           JNZ    03BB
03C7 8B4701         MOV    AX,[BX+01]
03CA BB5B05         MOV    BX,055B
03CD 43             INC    BX
03CE 031EFB00       ADD    BX,[00FB]
03D2 8A17           MOV    DL,[BX]
03D4 32F6           XOR    DH,DH
03D6 8BCA           MOV    CX,DX
03D8 0BC9           OR     CX,CX
03DA 7501           JNZ    03DD
03DC 41             INC    CX
03DD FFE0           JMP    AX

                                          ;* vstup prvnho znaku

03DF 3C1B         * CMP    AL,1B            ; je dic kd ESC ?
03E1 7505           JNZ    03E8             ; nen dic kd ESC
03E3 C7044D03       MOV    Word Ptr [SI],034D ; adresa po znaku <ESC>
03E7 C3             RET

03E8 E830FD       * CALL   011B             ; zobrazen znaku
03EB C706FD00DF03   MOV    Word Ptr [00FD],03DF ; adresa opakovn vstupu
03F1 C3             RET


                                          ;* posun pozice o CX dk/pozic
03F2 3827         * CMP    [BX],AH          ; je dosaeno hranice ?
03F4 7404           JZ     03FA             ; je dosaeno hranice
03F6 0007           ADD    [BX],AL          ; posun pozice
03F8 E2F8           LOOP   03F2             ; dal posun
                                          ;* nvrat z funkce  - nov pozice
03FA 8B160101     * MOV    DX,[0101]        ; nov pozice na displeji
03FE 33DB           XOR    BX,BX            ; aktivn strnka = 0
0400 B402           MOV    AH,02
0402 CD10           INT    10               ; nastaven nov pozice na displeji
0404 EBE5           JMP    03EB

                                          ;* povely H, f - nastaven pozice
0406 80F919         CMP    CL,19            ; je dek vy ne 25 ?
0409 77EF           JA     03FA             ; dek je vy
040B A00001         MOV    AL,[0100]        ; poet znak na dek
040E 8A6F01         MOV    CH,[BX+01]       ; poadovan pozice
0411 0AED           OR     CH,CH            ; je pozice ji = 0 ?
0413 7402           JZ     0417             ; je ji 0
0415 FECD           DEC    CH               ; pozice - 1
0417 3AC5         * CMP    AL,CH            ; je pekroena max. pozice ?
0419 7702           JA     041D             ; nen pekroena max. pozice
041B 8AE8           MOV    CH,AL            ; omezen na max. pozici
041D 86CD         * XCHG   CL,CH            ; CL<-pozice, CH<-dek
041F FECD           DEC    CH               ; dek - 1
0421 890E0101       MOV    [0101],CX        ; nastaven nov pozice displeje
0425 EBD3           JMP    03FA             ; nastaven kurzoru

                                          ;* povel C - posun o N pozic vpravo
0427 8A260001       MOV    AH,[0100]        ; poet znak na dek
042B B001           MOV    AL,01            ; posun o 1 znak vpravo
042D BB0101       * MOV    BX,0101          ; adresa pozice
0430 EBC0           JMP    03F2             ; nastaven nov pozice

                                          ;* povel D - posun o N pozic vlevo
0432 B8FF00         MOV    AX,00FF          ; min. pozice, posun vlevo
0435 EBF6           JMP    042D

                                          ;* povel A - posun o N dk nahoru
0437 B8FF00         MOV    AX,00FF          ; pznak posunu nahoru
043A BB0201       * MOV    BX,0102          ; adresa dku
043D EBB3           JMP    03F2             ; proveden posunu

                                          ;* povel B - posun o N dk dol
043F B80118         MOV    AX,1801          ; pznak posunu dol
0442 EBF6           JMP    043A             ; proveden posunu


                                          ;* povel s - uloen kurzoru
0444 A10101         MOV    AX,[0101]        ; souasn pozice kurzoru
0447 A30301         MOV    [0103],AX        ; schova pozice kurzoru
044A EBAE           JMP    03FA

                                          ;* povel u - navrcen kurzoru
044C A10301         MOV    AX,[0103]        ; uschovan pozice kurzoru
044F A30101         MOV    [0101],AX        ; nastaven nov aktivn pozice
0452 EBA6           JMP    03FA

                                          ;* povel m - nastaven atribut
0454 33C9           XOR    CX,CX
0456 860E0601       XCHG   CL,[0106]        ; poet parametr v bufferu
045A E8E400         CALL   0541             ; poskytnut adresy v bufferu
045D 41             INC    CX               ; poet parametr + 1
045E 8A07         * MOV    AL,[BX]          ; zadan parametr
0460 53             PUSH   BX               ; schova adresy bufferu
0461 BB5B00         MOV    BX,005B          ; tabulka atribut barev
0464 8A27           MOV    AH,[BX]          ; slo atributu
0466 83C303         ADD    BX,+03           ; zven adresy v tabulce
0469 80FCFF         CMP    AH,FF            ; je ji konec tabulky ?
046C 740F           JZ     047D             ; je konec tabulky
046E 3AE0           CMP    AH,AL            ; je zadan kd povelu ?
0470 75F2           JNZ    0464             ; nen zadan kd povelu
0472 8B47FE         MOV    AX,[BX-02]       ; maskovac slovo povelu
0475 20061501       AND    [0115],AL        ; maskovn AND
0479 08261501       OR     [0115],AH        ; maskovn OR
047D 5B           * POP    BX               ; adresa v tabulce parametr
047E 43             INC    BX               ; zven ukazatele na dal param.
047F E2DD           LOOP   045E             ; dal parametr
0481 E976FF         JMP    03FA

                                          ;* povel J - vymazn obrazovky
0484 33C9           XOR    CX,CX
0486 890E0101       MOV    [0101],CX        ; pozice do levho hornho rohu
048A B619           MOV    DH,19            ; posledn dek (25)
048C 8A160001     * MOV    DL,[0100]        ; posledn pozice displeje
0490 8A3E1501       MOV    BH,[0115]        ; videostrnka
0494 B80006         MOV    AX,0600          ; rolovn okna nahoru
0497 CD10           INT    10               ; vymazn obrazovky
0499 E95EFF         JMP    03FA

                                          ;* povel K - zruen zbytku dku
049C 8B0E0101       MOV    CX,[0101]        ; aktuln pozice kurzoru
04A0 8AF5           MOV    DH,CH            ; dek s kurzorem
04A2 EBE8           JMP    048C             ; vymazn zbytku dku


                                          ;* pevod sla na 2 znaky ASCII
04A4 B20A           MOV    DL,0A            ; konstanta k dlen
04A6 FEC0           INC    AL               ; slo + 1
04A8 32E4           XOR    AH,AH
04AA F6F2           DIV    DL               ; pevod na 2 znaky
04AC 053030         ADD    AX,3030          ; AH, AL=znaky sla
04AF C3             RET

                                          ;* povel n - dotaz na pozici

04B0 A00201         MOV    AL,[0102]        ; aktuln dek na displeji
04B3 E8EEFF         CALL   04A4             ; pevod na znaky ASCII
04B6 A30D01         MOV    [010D],AX        ; znaky sla dku
04B9 A00101         MOV    AL,[0101]        ; aktuln pozice na displeji
04BC E8E5FF         CALL   04A4             ; pevod na znaky ASCII
04BF A31001         MOV    [0110],AX        ; znaku sla pozice
04C2 C606080109     MOV    Byte Ptr [0108],09 ; poet znak k vstupu = 9
04C7 C70609010B01   MOV    Word Ptr [0109],010B ; adresa textu k vstupu
                                          ;* povel R - vstup pozice kurzoru
04CD E91BFF       * JMP    03EB             ; dn funkce


                                          ;* povel l - vypnut funkce WRAP
04D0 B101           MOV    CL,01            ; nov stav - vypnut WRAP
04D2 EB02           JMP    04D6
                                          ;* povel h - nastaven videomdu
04D4 33C9           XOR    CX,CX            ; nov stav - zapnut WRAP
04D6 8AC2         * MOV    AL,DL            ; poadovan videomd
04D8 3C07           CMP    AL,07            ; je videomd vt ne 7 ?
04DA 77F1           JA     04CD             ; chyba - neznm videomd
04DC 7206           JB     04E4             ; je nastaven videomdu
04DE 880EFA00       MOV    [00FA],CL        ; nastaven novho stavu WRAP
04E2 EBE9           JMP    04CD             ; nvrat
04E4 B400         * MOV    AH,00
04E6 CD10           INT    10               ; nastaven novho videomdu
04E8 EBE3           JMP    04CD             ; nvrat

                                          ;* parametr p - pedefinovn klvesy

04EA 33D2           XOR    DX,DX            ; DX <- 0
04EC 86160601       XCHG   DL,[0106]        ; poet bajt v bufferu
04F0 42             INC    DX
04F1 42             INC    DX
04F2 E84C00         CALL   0541             ; poskytnut adresy v bufferu
04F5 8B07           MOV    AX,[BX]          ; znak
04F7 E868FD         CALL   0262             ; nalezen klvesy v tabulce
04FA 751B           JNZ    0517             ; klvesa nenalezena
04FC 8BFB           MOV    DI,BX            ; adresa nalezen klvesy
04FE 290EFB00       SUB    [00FB],CX        ; snen dlky tabulky klves
0502 C606080100     MOV    Byte Ptr [0108],00 ; zruen bufferu klves
0507 8BF7           MOV    SI,DI            ; adresa klvesy
0509 03F1           ADD    SI,CX            ; adresa novho textu
050B B92306         MOV    CX,0623          ; adresa konce bufferu
050E 2BCE           SUB    CX,SI            ; dlka zbyl sti bufferu
0510 FC             CLD                     ; smr penosu nahoru
0511 06             PUSH   ES               ; schova ES
0512 0E             PUSH   CS
0513 07             POP    ES               ; ES <- CS
0514 F3             REPZ
0515 A4             MOVSB                   ; zruen klvesy z tabulky
0516 07             POP    ES               ; nvrat ES
0517 E82700       * CALL   0541             ; poskytnut adresy v bufferu
051A 80FA03         CMP    DL,03            ; dlka zadn
051D 7217           JB     0536             ; je mal dlka zadn
051F 8857FF         MOV    [BX-01],DL       ; nastaven novho potu znak
0522 0116FB00       ADD    [00FB],DX        ; zven dlky dat o klvesu
0526 03DA           ADD    BX,DX            ; zven adresy v bufferu
0528 813EFB00C800   CMP    Word Ptr [00FB],00C8 ; je ji pekroena max. dlka ?
052E 7206           JB     0536             ; nen pekroena dlka bufferu
0530 2BDA           SUB    BX,DX            ; nvrat pvodn pozice konce
0532 2916FB00       SUB    [00FB],DX        ; nvrat pvodn dlky bufferu
0536 C647FF00     * MOV    Byte Ptr [BX-01],00 ;
053A C706FD00DF03   MOV    Word Ptr [00FD],03DF
0540 C3             RET

                                          ;* zjitn adresy v bufferu
0541 8B1EFB00       MOV    BX,[00FB]        ; dlka dat v bufferu
0545 43             INC    BX               ; prvn bajt za klvesami
0546 031E0601       ADD    BX,[0106]        ; adres konce bufferu
054A 81FBD000       CMP    BX,00D0          ; je pekroen konec buffeur ?
054E 7206           JB     0556             ; nen pekroen konec bufferu
0550 FE0E0601       DEC    Byte Ptr [0106]  ; snen tae znak
0554 EBEB           JMP    0541             ; nov konec bufferu
0556 81C35B05     * ADD    BX,055B
055A C3             RET

                                          ;* tabulka pro pekdovn znak

055b               db        4,0,72h,10h
                   db        0d0h-4 dup(0)


; -----------------------------------------------------------------------------
;           Inicializace zazen - zde je konec rezidentn sti
; -----------------------------------------------------------------------------
                                          ;* inicializace zazen
062B CD11           INT    11               ; ten slova vybaven
062D 2430           AND    AL,30            ; inicializan videomd
062F 3C30           CMP    AL,30            ; je monochrom. md 80x25 ?
0631 7506           JNZ    0639             ; nen monochrom. md 80x25
0633 C706170100B0   MOV    Word Ptr [0117],B000 ; segment adresy pro MDA
0639 3C10         * CMP    AL,10            ; je videomd 40x25 barevn ?
063B 770A           JA     0647             ; je videomd 80x25
063D C606FF0000     MOV    Byte Ptr [00FF],00 ; standardn videomd = 0
0642 C606000127     MOV    Byte Ptr [0100],27 ; max. pozice = 39
0647 33DB         * XOR    BX,BX            ; BX <- 0
0649 8EDB           MOV    DS,BX            ; DS <- BX
064B BB6C00         MOV    BX,006C          ; peruen od klvesnice INT 1Bh
064E C707F200       MOV    Word Ptr [BX],00F2 ; vlastn obsluha INT 1Bh
0652 8C4F02         MOV    [BX+02],CS       ; segment obsluhy INT 1Bh
0655 BBA400         MOV    BX,00A4          ; vstup na displej INT 29h
0658 C707EB02       MOV    Word Ptr [BX],02EB ; vlastn obsluha INT 29h
065C 8C4F02         MOV    [BX+02],CS       ; segment vlastn obsluhy INT 29h
065F 2EC51E9E00     LDS    BX,CS:[009E]     ; adresa zhlav poadavku
0664 C7470E2B06     MOV    Word Ptr [BX+0E],062B ; koncov adresa rezid. sti
0669 8C4F10         MOV    [BX+10],CS       ; segment rezidentnho konce
066C E96FFA         JMP    00DE
